/* sdio.c */             
#include "basic.h"
#include "sdio.h"
#include "scsi_o2sd.h"
#define CC_TIMEOUT 20  
#define BRBW_TIMEOUT 50
#define WAIT_COUNT 1000000
//extern unsigned long volatile jiffies;
extern void set_pri_data(spinlock_t *lock,unsigned char* pri_data,unsigned char value);
int sdio_send_command(unsigned long membase, unsigned long cmddata, unsigned long argument)
{                                    
	unsigned long state;
	unsigned long flags;
	int i;
	/* check command enable or not */
//	while(1)
	for(i = 0;i<WAIT_COUNT;i++)
	{
		state = sdio_get_status(membase);
	/*
	if ((state & SDIO_CARD_INS) == 0)
		return 1;
	
	if (state & SDIO_CMDINHI)
	{
		return 2;
	}                                
	*/
	// must card presend and stable ,wait for cmd line ok
		if((state & SDIO_CMDINHI))// || (!(state & SDIO_CDDET_PIN)) || (!(state & SDIO_CARD_STB))) //|| ((state & 0x1F00000)!=0x1F00000))
		{
//			printk("waiting  for cmd line .....\n");
			
			schedule();
			if(signal_pending(current))
			{
				printk("wait cmd line ok received terminate signal\n");
				return -ERESTARTSYS;
			}
			
		}
		else
		{
//			printk("cmd line ok waitcount %d\n",i);
			break;
		}
		
	}
	if(i==WAIT_COUNT)
	{
		printk("error: wait cmd line count exceed is %d\n",i);	
		return -1;
	}
	if (cmddata & SDIO_CMD_DATA_PRESENT)
	{
//		while(1)
		for(i = 0;i<WAIT_COUNT;i++)
		{// wait for dat line ok
			state = sdio_get_status(membase);
			if((state & SDIO_DATINHI))// || (!(state & SDIO_CDDET_PIN)) )// || ((state & 0x1F00000)!=0x1F00000))
			{
//				printk("waiting for dat line\n");
				schedule();
				if(signal_pending(current))
				{
					printk("wait dat line ok received terminate signal\n");
					return -ERESTARTSYS;
				}
				
			}
			else
			{
//				printk("dat line ok waitcount %d\n",i);
				break;
			}
		}
	if(i==WAIT_COUNT)
	{
		printk("error: wait dat line count exceed is %d\n",i);
		return -1;
	}
	}
	
	/* set argument */
	mem_wDword(membase + 0x8, argument);
	
	/* issue command */                 
	mem_wDword(membase + 0xc, cmddata);   
	
// 	printk("after command code %X%X \n",cmddata >> 16, cmddata & 0xFFFF);
	return 0;
}

int sdio_send_Acommand(unsigned long membase, unsigned short RCA, unsigned long cmddata, unsigned long argument)
{
	EVENT Event=1;	
	unsigned long dwIntState;
	
	if ( sdio_send_command(membase, SD_CMD55, ((unsigned long)RCA) << 16) ) return 1;
	
	if (SDIO_CMDC_INTST == sdio_wait_commandcomplete_2(membase,&Event)) 
		return sdio_send_command(membase, cmddata, argument);
	else
		return 2;
}

unsigned long sdio_get_status(unsigned long membase)
{
	return mem_rDword(membase + 0x24);
}        

unsigned long sdio_get_interrupt(unsigned long membase)
{
	unsigned long intStatus = mem_rDword(membase + 0x30);
	mem_wDword(membase + 0x30, intStatus);
	
	return intStatus;
}

unsigned long sdio_reset(unsigned long membase)
{   
	mem_wWord( membase + 0x2E, 0xFFFF);
	return 0;
}

unsigned long sdio_setpower(unsigned long membase, unsigned short poweron)
{       
	unsigned short i;

	/* stop clock */
	sdio_setclock(membase, 0);
	
	if (poweron)
	{
		i = mem_rWord(membase + 0x28);
		i |= poweron;
		i |= SDIO_BUSPOW_ON;
		
		mem_wWord(membase + 0x28, i);   
		
		/* stop clock and enable internal clock */
                mem_wWord(membase + 0x2c, 1);
		
		sdio_setclock(membase, 1);
	}           
	else
	{                             
		i = mem_rWord(membase + 0x28);
		mem_wWord(membase + 0x28, i & (~ SDIO_BUSPOW_ON));
	}       
	
	return 0;
}

int sdio_phase_response(unsigned long membase, unsigned long cmddata)
{
	return 0;
}

int sdio_setclock(unsigned long membase, int clocktype)
{       
	unsigned short clockctrl;
	
	clockctrl = mem_rWord(membase + 0x2C);
	if(clocktype==0)
	{
		clockctrl &= (~SDIO_SDCLK_EN);
		mem_wWord(membase + 0x2C,clockctrl);// high speed start
		return 0;
	}

#define OZ128 1
#ifdef OZ128
	clockctrl &= 0xfffb;
	mem_wWord(membase + 0x2C,clockctrl);// stop

	clockctrl &= 0x00ff;
	mem_wWord(membase + 0x2C,clockctrl);// high speed start

	clockctrl |= 0x0004;
	mem_wWord(membase + 0x2C,clockctrl);// enable

	clockctrl &= 0xfffb;
	mem_wWord(membase + 0x2C,clockctrl);// stop

	switch(clocktype)
	{
	case 1:                              
		clockctrl |= (SDIO_BCLK_DIV128);
		break;
	case 2:
		clockctrl |= (SDIO_BCLK_DIV8);
		break;
	case 3:
		clockctrl |= (SDIO_BCLK_DIV0);
		break;
	default:
		/* off */
		clockctrl &= (~SDIO_SDCLK_EN);
		break;
	}                                 
	mem_wWord(membase + 0x2C,clockctrl);
	clockctrl |= 0x0004;
	mem_wWord(membase + 0x2C,clockctrl);
	
#else
	switch(clocktype)
	{
	case 1:                              
		clockctrl &= 0xFF;
		clockctrl |= (SDIO_BCLK_DIV128 + SDIO_SDCLK_EN);
		break;
	case 2:
		clockctrl &= 0xFF;
		clockctrl |= (SDIO_BCLK_DIV8 + SDIO_SDCLK_EN);
		break;
	case 3:
		clockctrl &= 0xFF;
		clockctrl |= (SDIO_BCLK_DIV0 + SDIO_SDCLK_EN);
		break;
	default:
		/* off */
		clockctrl &= (~SDIO_SDCLK_EN);
		break;
	}                                 
	
	mem_wWord(membase + 0x2C, clockctrl);
#endif	
	return 0;
}
int sdio_wait_commandcomplete_2(unsigned long membase, EVENT* pEvent)
{ 
	long ret = SDIO_CMDC_INTST;
	long ret2; 
	int i;
#ifdef WAIT_CC_POLLING 
	unsigned long dwIntState;
	o2sd_pri_data.sdio_NeedCancel = 0;
	for(i=0;i<WAIT_COUNT;i++)
//	while(1)
	{
		if (o2sd_pri_data.sdio_NeedCancel)
		{
			printk("need cancel in wait cmd complete\n");
			ret = -1;
			break;
		}
		if(o2sd_pri_data.sdio_err!=0)
		{
			printk("error happen in wait cmd complete\n");
			set_pri_data(&(o2sd_pri_data.sdio_err_lock),&(o2sd_pri_data.sdio_err),0);
			ret = -1;
			break;
		}
		dwIntState = sdio_get_interrupt(membase);
		if (dwIntState & SDIO_CMDC_INTST) 
		{
			ret = SDIO_CMDC_INTST;
			break;
		}
		if (dwIntState & 0x8000)
		{
			printk("error happend in wait cmd complete,but interrupt dispear\n");
			ret = -1;
			break;
		}
		/*
		if (dwIntState & SDIO_CRMV_INTST)
		{
			printk("card remove in wait cmd complete\n");
			ret = -1;
			break;
		} 
		if (dwIntState & SDIO_CIST_INTST) 
		{
			printk("card insert in wait cmd complete\n");
			ret = -1;
			break;
		}
		*/
//		printk("waiting for cmd complete\n");	
		schedule();
		if(signal_pending(current))
		{
			printk("wait cmd complete received terminate signal\n");
			ret = -ERESTARTSYS;
			break;
		}
			
	}
	if(i==WAIT_COUNT)
	{
		printk("error: wait cmd complete count exceed is %d\n",i);
		return -1;
	}
	return ret;
#else
	ret2 = wait_event_interruptible(o2sd_pri_data.o2sd_cc_event,o2sd_pri_data.o2sd_cc);
	if(ret2==0)
		ret = 0;
	else if(ret2==-ERESTARTSYS)
	{
		printk("thread of wait o2sd_cc  received terminate\n");
		ret = -1;
	}
	else
	{
		printk("error value of waiting for o2sd_cc ret=%d\n",ret2);
		ret = -1;
	}
	/*
	waked so clear o2sd_cc  .
	*/
	set_pri_data(&(o2sd_pri_data.cc_lock),&(o2sd_pri_data.o2sd_cc),0);
	if(o2sd_pri_data.sdio_err!=0)
	{
		set_pri_data(&(o2sd_pri_data.sdio_err_lock),&(o2sd_pri_data.sdio_err),0);
		printk("error happen in wait cmd complete\n");
		return -1;
	}
	return ret;
#endif
}
int sdio_wait_bufferready_3(unsigned long membase)
{
	unsigned long flags;	
	long ret = SDIO_BUF_RDE;
	long ret2;
	int i;
#ifndef WAIT_BR_POLLING
	ret2 = wait_event_interruptible(o2sd_pri_data.o2sd_br_event,o2sd_pri_data.o2sd_br);
	if(ret2==0)
		ret = 0;
	else if(ret2==-ERESTARTSYS)
	{
		printk("thread of wait o2sd_br  received terminate\n");
		ret = -1;
	}
	else
	{
		printk("error value of waiting for o2sd_br ret=%d\n",ret2);
		ret = -1;
	}
	/*
	waked so clear o2sd_br  .
	*/
	set_pri_data(&(o2sd_pri_data.br_lock),&(o2sd_pri_data.o2sd_br),0);
	if(o2sd_pri_data.sdio_err!=0)
	{
		printk("error happen in wait buffer read ready\n");
		set_pri_data(&(o2sd_pri_data.sdio_err_lock),&(o2sd_pri_data.sdio_err),0);
		return -1;
	}
	return ret;
#else
	unsigned long dwState;
	o2sd_pri_data.sdio_NeedCancel = 0;
//	while(1)
	for(i = 0;i<WAIT_COUNT;i++)
	{
//		dwState = sdio_get_status(membase);
		dwState = sdio_get_interrupt(membase);
//		if (dwState & SDIO_BUF_RDE)
		if (dwState & 0x20)
		{
			ret = SDIO_BUF_RDE;
			break;
		}
		if (o2sd_pri_data.sdio_err!=0)
		{
			printk("error happen in wait buffer read ready \n");
			set_pri_data(&(o2sd_pri_data.sdio_err_lock),&(o2sd_pri_data.sdio_err),0);
			ret = -1;
			break;
		}
		if (o2sd_pri_data.sdio_NeedCancel)
		{
			printk("need cancel in wait buffer read ready\n");
			ret = -1;
			break;
		}
//		printk("waiting for read buffer ready\n");
		schedule();
		if(signal_pending(current))
		{
//			printk("wait buffer read ready received terminate signal\n");
			ret = -ERESTARTSYS;
			break;
		}
		
	}
	if(i==WAIT_COUNT)
	{
		printk("error: wait buffer read ready count exceed is %d\n",i);
		return -1;
	}
	return ret;
#endif
}
int sdio_wait_bufferready_4(unsigned long membase)
{
	long ret = SDIO_BUF_WRE;
	long ret2;
	int i;
#ifndef WAIT_BW_POLLING	
	unsigned long flags;	
	ret2 = wait_event_interruptible(o2sd_pri_data.o2sd_bw_event,o2sd_pri_data.o2sd_bw);
	if(ret2==0)
		ret = 0;
	else if(ret2==-ERESTARTSYS)
	{
		printk("thread of wait o2sd_bw  received terminate\n");
		ret = -1;
	}
	else
	{
		printk("error value of waiting for o2sd_bw ret=%d\n",ret2);
		ret = -1;
	}
	/*
	waked so clear o2sd_bw  .
	*/
	set_pri_data(&(o2sd_pri_data.bw_lock),&(o2sd_pri_data.o2sd_bw),0);
	if(o2sd_pri_data.sdio_err!=0)
	{
		printk("error happen in wait buffer write ready\n");
		set_pri_data(&(o2sd_pri_data.sdio_err_lock),&(o2sd_pri_data.sdio_err),0);
		return -1;
	}
	return ret;
#else
	unsigned long dwState;
	o2sd_pri_data.sdio_NeedCancel = 0;
//	while(1)
	for(i = 0;i<WAIT_COUNT;i++)
	{
//		dwState = sdio_get_status(membase);
		dwState = sdio_get_interrupt(membase);
//		if (dwState & SDIO_BUF_WRE)
		if (dwState & 0x10)
		{
			ret = SDIO_BUF_WRE;
			break;
		}
		if (o2sd_pri_data.sdio_err!=0)
		{
			printk("error happen in wait buffer write ready\n");
			set_pri_data(&(o2sd_pri_data.sdio_err_lock),&(o2sd_pri_data.sdio_err),0);
			ret = -1;
			break;
		}
		if (o2sd_pri_data.sdio_NeedCancel)
		{
			printk("need cancel in wait buffer write ready\n");
			ret = -1;
			break;
		}
//		printk("waiting for write buffer ready\n");
		schedule();
		if(signal_pending(current))
		{
//			printk("wait buffer write ready received terminate signal\n");
			ret = -ERESTARTSYS;
			break;
		}
		
	}
	if(i==WAIT_COUNT)
	{
		printk("error: wait buffer write ready count exceed is %d\n",i);
		return -1;
	}
	return ret;
#endif
}

int sdio_response_pharse(unsigned long membase, struct sdio_phy_registers* r, unsigned long Type)
{    
	if (r == NULL) return -1;
	if (membase == 0) return 1;
	
	switch(Type)
	{
	case SDIO_RESPONSE_TYPE_ELLEN_STATUS:
		r->STATUS = mem_rDword(membase + 0x10);
		break;
	case SDIO_RESPONSE_TYPE_ELLEN_OCR:
		r->OCR = mem_rDword(membase + 0x10);
		break;
	case SDIO_RESPONSE_TYPE_ELLEN_CID:
		memcpy(&r->CID, membase + 0x10, sizeof(r->CID));
		break;
	case SDIO_RESPONSE_TYPE_ELLEN_CSD:
		memcpy(&r->CSD, membase + 0x10, sizeof(r->CSD));
		break;
	case SDIO_RESPONSE_TYPE_ELLEN_RCA:
		r->RCA = mem_rWord(membase + 0x12);
		break;
	}
	
	return 0;
}
void 	sdio_clear_before_iden(unsigned long membase)
{
	set_pri_data(&(o2sd_pri_data.sdio_err_lock),&(o2sd_pri_data.sdio_err),0);
		set_pri_data(&(o2sd_pri_data.tc_lock),&(o2sd_pri_data.o2sd_tc),0);
	mem_wDword(membase+0x30,0xffffffff);	
}
