#include "basic.h"
#include "sdioif.h"
#include "scsi_o2sd.h"
#include "sdio.h"
 
#define TC_TIMEOUT 20
extern void set_pri_data(spinlock_t *lock,unsigned char* pri_data,unsigned char value);
static int MMC_CaculateCapacity(  sdio_card_desc* Card)
{          
#ifdef MEMBER_ALIGN_OFF
	
#else
        unsigned long t1 = 0,t2 = 0,lba = 0;
        lba = ( (unsigned long)Card->r.CSD[7] & 0xFF ) << 2;
        t1 = (((unsigned long)Card->r.CSD[6]) & 0xc0) >> 6;
        t2 = (((unsigned long)Card->r.CSD[8]) & 0x03) << 10;
	
	lba += t1 + t2 + 1;

        t1 = ((unsigned long)Card->r.CSD[4] & 0xFF ) >> 7;
        t2 = (((unsigned long)Card->r.CSD[5] & 0x03) & 3) << 1;
	t2 += t1;
	
	lba *= 4 << t2;
	
        t1 = ((unsigned long)Card->r.CSD[9] & 0x0F) ;
	
        lba *= 1 << t1;
	
	lba /= Card->BlockSize; 
	
#endif	
	
	return Card->LBACount = lba;
}

static int MMC_Identify(  sdio_card_desc* Card)
{
	int i;
	sdio_clear_before_iden(Card->membase);
	Card->BlockSize = 0x200;
	
	if(sdio_send_command(Card->membase, MMC_CMD00, 0)<0)
	{
		printk("send cmd %d failed in mmc identify\n",MMC_CMD00); 
		return 2;
	}
	if (sdio_wait_commandcomplete_2(Card->membase,&Card->Event)<0) return 2;
	/*
	Here we must wait for some time, as the cmd00(reset) is issued.
	Otherwise, the device will not deal the following command successfully. 
	*/
	for(i=0;i<10000000;i++);

	do
	{
		if(sdio_send_command(Card->membase, MMC_CMD01, Card->OCR)<0)return 3;
		if (sdio_wait_commandcomplete_2(Card->membase,&Card->Event)<0) return 3;
		sdio_response_pharse(Card->membase, &Card->r, SDIO_RESPONSE_TYPE_ELLEN_OCR);
				
		/* check power condition match */
		if ((Card->OCR & Card->r.OCR) == 0) return 4;

	} while ((Card->r.OCR & SDIO_RESPONSE_CARD_POWERUP_FREE) == 0);

	if(sdio_send_command(Card->membase, MMC_CMD02, 0)<0)return 4;
	if (sdio_wait_commandcomplete_2(Card->membase,&Card->Event)<0) return 4;
	sdio_response_pharse(Card->membase, &Card->r, SDIO_RESPONSE_TYPE_ELLEN_CID);
	
	if(sdio_send_command(Card->membase, MMC_CMD03, 0x10000)<0)return 5;
	if (sdio_wait_commandcomplete_2(Card->membase,&Card->Event)<0) return 5;
	sdio_response_pharse(Card->membase, &Card->r, SDIO_RESPONSE_TYPE_ELLEN_STATUS);
		
	if(sdio_send_command(Card->membase, MMC_CMD09, 0x10000)<0)return 6;
	if (sdio_wait_commandcomplete_2(Card->membase,&Card->Event)<0) return 6;
	sdio_response_pharse(Card->membase, &Card->r, SDIO_RESPONSE_TYPE_ELLEN_CSD); 
	
#ifdef MEMBER_ALIGN_OFF
#else 
	if (MMC_CaculateCapacity(Card) == 0) return 0x10;
//	MMC_CaculateCapacity(Card);
#endif	
	
	if(sdio_send_command(Card->membase, MMC_CMD07, 0x10000)<0)return 7;
	if (sdio_wait_commandcomplete_2(Card->membase,&Card->Event)<0) return 7;
	sdio_response_pharse(Card->membase, &Card->r, SDIO_RESPONSE_TYPE_ELLEN_STATUS);

	if (9 != (Card->r.CSD[9] & 0x0F))
	{
		if(sdio_send_command(Card->membase, MMC_CMD16, Card->BlockSize)<0)return 8;
		if(sdio_wait_commandcomplete_2(Card->membase,&Card->Event)<0) return 8;
		sdio_response_pharse(Card->membase, &Card->r, SDIO_RESPONSE_TYPE_ELLEN_STATUS);
	}

	mem_wWord(Card->membase + 0x04, Card->BlockSize);

	/* change clock to transfer clock */
	sdio_setclock(Card->membase, 3);
	sdio_setclock(Card->membase, 0);
	sdio_setclock(Card->membase, 3);
	
	/* set time out value */
	mem_wWord(Card->membase + 0x2E, 0x0E);
	
	Card->slot = 0;
	
	return 0;
}

static int SD_Identify(sdio_card_desc* Card)
{
	int i;
        unsigned short wHostControl;
	sdio_clear_before_iden(Card->membase);
	Card->BlockSize = 0x200;
	if(sdio_send_command(Card->membase, MMC_CMD00, 0)<0)return 2;



	if (sdio_wait_commandcomplete_2(Card->membase,&Card->Event)<0) 
	{
		printk("sd_identify:wait cmd00 failed\n");
		return 2;
	}
	/*
	Here we must wait for some time, as the cmd00(reset) is issued.
	Otherwise, the device will not deal the following command successfully. 
	*/
	for(i=0;i<100000000;i++);
	do
	{
		if(0==sdio_send_Acommand(Card->membase, 0, SD_ACMD41, Card->OCR))		
		{
			if ( sdio_wait_commandcomplete_2(Card->membase,&Card->Event)<0) return 3;
			sdio_response_pharse(Card->membase, &Card->r, SDIO_RESPONSE_TYPE_ELLEN_OCR);
		}
		else
		{
//			printk("sd_identify:acmd41 failed\n");
			return 2;
		}
		/* check power condition match */
		if ((Card->OCR & Card->r.OCR) == 0) return 4;
	} while ((Card->r.OCR & SDIO_RESPONSE_CARD_POWERUP_FREE) == 0);
	if(sdio_send_command(Card->membase, SD_CMD02, 0)<0)return 4;
	if (sdio_wait_commandcomplete_2(Card->membase,&Card->Event)<0)
	{
		printk("sd_identify:wait cmd02 failed\n");
		return 4;
	}
	sdio_response_pharse(Card->membase, &Card->r, SDIO_RESPONSE_TYPE_ELLEN_CID);
		
	if(sdio_send_command(Card->membase, MMC_CMD03, 0x0000)<0)return 5;
	if (sdio_wait_commandcomplete_2(Card->membase,&Card->Event)<0)
	{
		printk("sd_identify:wait cmd03 failed\n");
		return 5;
	}
	sdio_response_pharse(Card->membase, &Card->r, SDIO_RESPONSE_TYPE_ELLEN_RCA);  
	
	if(sdio_send_command(Card->membase, MMC_CMD09, ((unsigned long)Card->r.RCA) << 16)<0)return 5;
	if (sdio_wait_commandcomplete_2(Card->membase,&Card->Event)<0) return 5;
	sdio_response_pharse(Card->membase, &Card->r, SDIO_RESPONSE_TYPE_ELLEN_CSD);
	
	#ifdef MEMBER_ALIGN_OFF
	#else 
		if (MMC_CaculateCapacity(Card) == 0 ) return 0x10;
	#endif	

	if(sdio_send_command(Card->membase, MMC_CMD07, ((unsigned long)Card->r.RCA) << 16)<0)return 5;
	if (sdio_wait_commandcomplete_2(Card->membase,&Card->Event)<0) return 5;
	sdio_response_pharse(Card->membase, &Card->r, SDIO_RESPONSE_TYPE_ELLEN_RCA);

	if (9 != (Card->r.CSD[9] & 0x0F))
	{
		if(sdio_send_command(Card->membase, MMC_CMD16, Card->BlockSize)<0)return 8;
		if (sdio_wait_commandcomplete_2(Card->membase,&Card->Event)<0) return 8;
		sdio_response_pharse(Card->membase, &Card->r, SDIO_RESPONSE_TYPE_ELLEN_STATUS);
	}

	mem_wWord(Card->membase + 0x04, Card->BlockSize);

/*
	wHostControl = mem_rWord(Card->membase + 0x28);
	mem_wWord(Card->membase + 0x28, wHostControl | SDIO_BUS_4);
*/        

	/* change clock to transfer clock */
	sdio_setclock(Card->membase, 3);
	sdio_setclock(Card->membase, 0);
	sdio_setclock(Card->membase, 3);
	
	/* set time out value */
	mem_wWord(Card->membase + 0x2E, 0x0E);

        return 0;
}


/* sdio_if_init
 *     this function initialize the sdio function.
 *     param: PciDevice -> point to the pci context for access the sdio host controller
 *            pHostDevice -> caller must initialize this variable first, initialize function will fill the data
 */
int sdio_if_init(unsigned long membase, sdio_host_desc* pHostDevice)
{
	unsigned long i;
	unsigned long dwData;
	pHostDevice->memiobase = membase;
	pHostDevice->NumberOfSlots = 1;
	// reset first???
	sdio_if_hostreset(pHostDevice);
	for(i=0;i<10000000;i++);
	
	
	/* get slot information */

	// please refer to the sdio.h.
	// if you change the micro define at the end of sdio.h, we must change here.

	/*
	interrupt status enable:
	
		error
		card insert
		card remove
		buffer read ready
		buffer write ready
		transfer complete
		command complete
		
	
	interrupt status disable
	
		card interrupt
		block gap 
	*/
	
	/*
	interrupt signal enable:
		error
		card insert
		card remove
		(condition)buffer read ready
		(condition)buffer write ready
		(condition)command complete
		
	interrupt signal disable:
		card interrupt
		block gap
		transfer complete // we enable this in read/write.
	*/
	// clean interrupt status first	
	mem_wDword((unsigned long)pHostDevice->memiobase + 0x30, 0xFFFFFFFF);
	
	// set status enable & disable
	mem_wDword((unsigned long)pHostDevice->memiobase + 0x34, 0xFFFFFEF3);
	
	// set signal enable & disable
	mem_wDword((unsigned long)pHostDevice->memiobase + 0x38, 0xFFFFFEC0);

#ifndef WAIT_CC_POLLING
	dwData = mem_rDword((unsigned long)pHostDevice->memiobase + 0x38);
	mem_wDword((unsigned long)pHostDevice->memiobase+0x38,dwData | SDIO_CMDC_UNMASK);
#endif
#ifndef WAIT_BR_POLLING
	dwData = mem_rDword((unsigned long)pHostDevice->memiobase + 0x38);
	mem_wDword((unsigned long)pHostDevice->memiobase+0x38,dwData | SDIO_BFRR_UNMASK);
#endif
#ifndef WAIT_BW_POLLING
	dwData = mem_rDword((unsigned long)pHostDevice->memiobase + 0x38);
	mem_wDword((unsigned long)pHostDevice->memiobase+0x38,dwData | SDIO_BFWR_UNMASK);
#endif	
 
	
	return 0;
}
int sdio_if_host_suspend(sdio_card_desc* Card)
{
//	sdio_reset(Card->membase);
	mem_wWord(Card->membase+0x38,0x00);
	mem_wWord(Card->membase+0x3a,0x00);
	mem_wWord(Card->membase+0x28,0x00);
	unsigned long data1;
	data1 = mem_rWord(Card->membase+0x2c);
	data1 &= 0xfffb;
	mem_wWord(Card->membase+0x2c,data1);
	return TRUE;
}
int sdio_if_host_resume(sdio_card_desc* Card)
{
//	if(mem_rWord(Card->membase+0x26) & 0x0004)
//		mem_wWord(Card->membase+0x28,0x0c00);
	return TRUE;
}
int sdio_if_cleanup( sdio_host_desc* pHostDevice)
{
	/*all successful*/
	mem_wDword(pHostDevice->memiobase + 0x38, 0);
	sdio_setpower(pHostDevice->memiobase, 0);	
	return 0;
}

int sdio_if_getcardinfo(  sdio_card_desc* Card)
{
	unsigned short data;
	int result;
	int i;
	unsigned long state;
	Card->membase = Card->pHostDevice->memiobase;
	Card->slot = 0;            
	
	
	if (((sdio_get_status(Card->membase) & (SDIO_CARD_INS + SDIO_CARD_STB))) == (SDIO_CARD_INS + SDIO_CARD_STB))
	{
		Card->PresentState = sdio_get_status(Card->membase);
	}
	else
	{
		return 1; /* not is not inserted or stable*/
	}

	Card->Capabilities	= mem_rDword(Card->membase + 0x40);
	
	data = mem_rWord(Card->membase + 0x42);      
	
	Card->OCR = 0;
	if (data & 0x0400) 
	{
		Card->PowerSelect = SDIO_BUSVOL18;
		Card->OCR |= 0x00000060;
	}
	
	if (data & 0x0200)
	{
		Card->PowerSelect = SDIO_BUSVOL30;
		Card->OCR |= 0x00060000;
	}
	
	if (data & 0x0100)
	{
		Card->PowerSelect = SDIO_BUSVOL33;
		Card->OCR |= 0x00300000;
	}

	sdio_setpower(Card->membase, Card->PowerSelect);
	result = MMC_Identify(Card);
	if (result)
	{
		result = SD_Identify(Card);
	}

//	result = MMC_Identify(Card);
	return result;
}

int sdio_if_readsector( sdio_card_desc* Card,   void* buffer,  unsigned long block_address,  unsigned long block_count)
{// we do not support read Multi sectors once. if we support it like 'write', the speed will
// faster than now? by now the read speed is ok, so do not support it.
  
	unsigned long temp;
	char* ptBuffer = (char*)buffer;
	int Read = 0;
	if (buffer == NULL) return 0;
	/* prepare the SDIO package */
#ifdef SDIO_READ_MULTI	
	if(block_count>1)
	{
		if(sdio_if_readMsector(Card,buffer,block_address,block_count)==0)
			Read = Card->BlockSize * block_count;
		else
			return Read;	
	}
	else if(block_count>0)
	{
		if(sdio_if_readAsector(Card,buffer,block_address)==0)
			Read = Card->BlockSize;
		else
			return Read;	
	}
	else
		printk("error block_count for read\n");		
#else
        while (block_count-- > 0)
	{	
//		temp = jiffies;
//		printk("jiffies before read sector %d\n",temp);
		if (sdio_if_readAsector(Card, ptBuffer, block_address ++) == 0)
		{
			Read += Card->BlockSize;
			ptBuffer+= Card->BlockSize;
		}
		else
		{
			break;
		}
	}
#endif
//	printk("endif readsector\n");
	return Read;	
}            
                                                             
int sdio_if_writesector( sdio_card_desc* Card,  void* buffer,  unsigned long block_address,  unsigned long block_count)
{
	char* ptBuffer = (char*)buffer;
	int Wrotten = 0;
	
	if (buffer == NULL) return 0;
	
	/* prepare the SDIO package */
#ifdef SDIO_WRITE_MULTI	
	if(block_count>1)
	{
		if(sdio_if_writeMsector(Card,buffer,block_address,block_count)==0)
			Wrotten = Card->BlockSize * block_count;
		else
			return Wrotten;	
	}
	else if(block_count>0)
	{
		if(sdio_if_writeAsector(Card,buffer,block_address)==0)
			Wrotten = Card->BlockSize;
		else
			return Wrotten;	
	}
	else
		printk("error block_count for write\n");		
#else
        while (block_count-- > 0)
	{
		if (sdio_if_writeAsector(Card, ptBuffer, block_address ++) == 0)
		{
			Wrotten += Card->BlockSize;
			ptBuffer+= Card->BlockSize;
		}
		else
		{
			break;
		}
	}
#endif	

	return Wrotten;	
}
int sdio_if_interrupt_handler(sdio_host_desc* pHostDevice )
{
	long ret=-1;
	unsigned long i;
	unsigned short j;
	unsigned long flags;
	
	i = mem_rDword(pHostDevice->memiobase + 0x30);   
 
	
	// we clear intr reg, but if the interrupt happen before we check the interrupt status for polling mode, ......haha
//	mem_wDword(pHostDevice->memiobase + 0x30, i);


	if (i & 0x80)
	{
		/*card remove*/
		o2sd_clear_cardexist();
		mem_wDword(pHostDevice->memiobase + 0x30, i);
		o2sd_pri_data.sdio_NeedCancel = 1;
		o2sd_set_intrflags();
//		event_Set(0,i);
//		event_Set(1,i);
		return 0;
	}

	if (i & 0x40)
	{
		/*card insert*/
//		printk("card insert interrupt\n");	
		o2sd_set_cardexist();
		mem_wDword(pHostDevice->memiobase + 0x30, i);
		o2sd_pri_data.sdio_NeedCancel = 1;
		o2sd_set_intrflags();
//		event_Set(0,i);
//		event_Set(1,i);
		return 0;
	}

#ifndef WAIT_BR_POLLING
	if (i & 0x20)
	{
		/*buffer read ready*/
//		printk("buffer read ready interrupt\n");	
//		event_Set(0,i);
//		event_Set(1,i);
		mem_wDword(pHostDevice->memiobase + 0x30, 0x20);
		set_pri_data(&(o2sd_pri_data.br_lock),&(o2sd_pri_data.o2sd_br),1);
//		if(waitqueue_active(&(o2sd_pri_data.o2sd_br_event)))
		{
			wake_up_interruptible(&(o2sd_pri_data.o2sd_br_event));
		}
		ret = 0;
	}
#endif	
#ifndef WAIT_BW_POLLING
	if (i & 0x10)
	{
		/*buffer write ready*/
//		printk("buffer write ready interrupt\n");	
//		event_Set(0,i);
//		event_Set(1,i);
		mem_wDword(pHostDevice->memiobase + 0x30, 0x10);
		set_pri_data(&(o2sd_pri_data.bw_lock),&(o2sd_pri_data.o2sd_bw),1);
//		if(waitqueue_active(&(o2sd_pri_data.o2sd_bw_event)))
		{
			wake_up_interruptible(&(o2sd_pri_data.o2sd_bw_event));
		}
		ret = 0;
	}
#endif

#ifndef WAIT_CC_POLLING
	if (i & 0x01)
	{
		/*command complete*/
		printk("command complete interrupt\n");	
//		event_Set(0,i);
//		event_Set(1,i);
		mem_wDword(pHostDevice->memiobase + 0x30, 0x01);
		set_pri_data(&(o2sd_pri_data.cc_lock),&(o2sd_pri_data.o2sd_cc),1);
		// add this condition ?
//		if(waitqueue_active(&(o2sd_pri_data.o2sd_cc_event)))
		{
			wake_up_interruptible(&(o2sd_pri_data.o2sd_cc_event));
		}
		ret = 0;
	}
#endif

#ifdef SDIO_TC_INTERRUPT
	if (i & 0x02)
	{
//		printk("transfer complete interrupt\n");	
		mem_wDword(pHostDevice->memiobase + 0x30, i);
		set_pri_data(&(o2sd_pri_data.tc_lock),&(o2sd_pri_data.o2sd_tc),1);
//		if(waitqueue_active(&(o2sd_pri_data.o2sd_tc_event)))
		{
			wake_up_interruptible(&(o2sd_pri_data.o2sd_tc_event));
		}
		ret = 0;
		/*transfer complete*/
//		event_Set(0,i);
//		event_Set(1,i);
	}
#endif
	
	if (i & 0x04)
	{
		/*block gap*/
		printk("error:block gap interrupt happen\n");
		mem_wDword(pHostDevice->memiobase + 0x30, i);
		ret = 0;
//		event_Set(0,i);
//		event_Set(1,i);
	}
	if (i & 0x8000)
	{
		j = mem_rWord(pHostDevice->memiobase + 0x32);   
		printk("error interrupt %x\n",j);
		mem_wWord(pHostDevice->memiobase + 0x32, j);
//		mem_wDword(pHostDevice->memiobase + 0x30, i);
		set_pri_data(&(o2sd_pri_data.sdio_err_lock),&(o2sd_pri_data.sdio_err),1);
#ifndef WAIT_CC_POLLING
//		if(waitqueue_active(&(o2sd_pri_data.o2sd_cc_event)))
		{
			set_pri_data(&(o2sd_pri_data.cc_lock),&(o2sd_pri_data.o2sd_cc),1);
			wake_up_interruptible(&(o2sd_pri_data.o2sd_cc_event));
		}
#endif
#ifndef WAIT_BR_POLLING
//		if(waitqueue_active(&(o2sd_pri_data.o2sd_br_event)))
		{
			set_pri_data(&(o2sd_pri_data.br_lock),&(o2sd_pri_data.o2sd_br),1);
			wake_up_interruptible(&(o2sd_pri_data.o2sd_br_event));
		}
#endif
#ifndef WAIT_BW_POLLING
//		if(waitqueue_active(&(o2sd_pri_data.o2sd_bw_event)))
		{
			set_pri_data(&(o2sd_pri_data.bw_lock),&(o2sd_pri_data.o2sd_bw),1);
			wake_up_interruptible(&(o2sd_pri_data.o2sd_bw_event));
		}
#endif
#ifdef SDIO_TC_INTERRUPT
//		if(waitqueue_active(&(o2sd_pri_data.o2sd_tc_event)))
		{
			set_pri_data(&(o2sd_pri_data.tc_lock),&(o2sd_pri_data.o2sd_tc),1);
			wake_up_interruptible(&(o2sd_pri_data.o2sd_tc_event));
		}
		ret = 0;
		
	}
#endif
	if(ret!=0)
		printk("other interrupt i=%x\n",i);	
	return 0;
}

int sdio_if_interrupt_claim( sdio_host_desc* pHostDevice)
{        
	unsigned long i=0;
	unsigned long x=0;
//	x = mem_rDword(pHostDevice->memiobase + 0x38);
//	printk("signal enable reg = %x\n",x);	
	i = mem_rDword(pHostDevice->memiobase + 0x30);
	if( (i&0x80)||(i&0x40))
		return 1;
#ifndef WAIT_BR_POLLING
	if(i&0x20)
		return 1;
#endif
#ifndef WAIT_BW_POLLING
	if(i&0x10)
		return 1;
#endif 	
#ifndef WAIT_CC_POLLING
	if(i&0x01)
		return 1;
#endif
#ifdef SDIO_TC_INTERRUPT
	if(i&0x02)
		return 1;
#endif
	if(i&0x8000)
		return 1;

	return 0;
}                       

int sdio_if_hostreset( sdio_host_desc* pHostDevice)
{
	sdio_reset(pHostDevice->memiobase);	
	
	return 0;
}

int sdio_if_cardreset( sdio_card_desc* Card)
{   
	/* RESET card signal*/
	return 0;	
	mem_wWord(Card->membase + 0x2E, 0x100);
//	printk("card reset\n");	
	return sdio_if_getcardinfo(Card);
}
int sdio_if_chkMediaExistTrue( sdio_card_desc* Card)
{
	unsigned long state = mem_rDword(Card->membase + 0x26);
	
	return (int)((state & 3) == 3);
}

int sdio_if_chkMediaExist( sdio_card_desc* Card)
{
	return o2sd_check_cardexist();

	unsigned long state = mem_rDword(Card->membase + 0x26);
	
	return (int)((state & 3) == 3);
}

int sdio_if_chkWriteProtect( sdio_card_desc* Card)
{
	unsigned long dat1 = mem_rDword(Card->membase + 0x26);
	int x = (int)((dat1 & 0x08) == 0x0);
//	printk("write protect is %d\n",x);
	return x;

}

int sdio_if_readAsector( sdio_card_desc* Card,   void* buffer,  unsigned long block_address)
{
	long ret,ret2;
	unsigned long temp,temp2; 
	unsigned long State;
	unsigned long flags;
	unsigned long* lbuf = (unsigned long)buffer;
	int Read = 0;
	int i;

//	temp = jiffies;
	/* clean fifo */
	while ((State = sdio_get_status(Card->membase)) & SDIO_BUF_RDE) 
	{
	//	PDEBUG("read:clean fifo for read ready, State = %x", State); 
		mem_rDword(Card->membase + 0x20);
	}
	while ((State = sdio_get_status(Card->membase)) & SDIO_BUF_WRE) 
	{
		PDEBUG("read:clean fifo for write ready"); 
		mem_wDword(Card->membase + 0x20, 0);
	}
	/*
	if(State & (SDIO_RDT_ACT + SDIO_WRT_ACT + SDIO_DAT_ACT + SDIO_DATINHI + SDIO_CMDINHI))
	{
		printk("State not ready %x\n",State);
		return -1;
	}
	*/
	if ((State & SDIO_CARD_INS) == 0)
	{
		printk("Status not ready for read SDIO_CARD_INS\n");
		 return 2;
	}
	
	if (Card->BlockSize == 0 || Card->LBACount == 0) return 3;
	
	if (block_address >= Card->LBACount) return 4;
	
	block_address *= Card->BlockSize;

        sdio_get_interrupt(Card->membase);

	if(sdio_send_command(Card->membase, MMC_CMD17, block_address)<0)return 5;
//	if (sdio_wait_commandcomplete_2(Card->membase,&Card->Event)<0) return 5;
/*	sdio_response_pharse(Card->membase, &Card->r, SDIO_RESPONSE_TYPE_ELLEN_STATUS); 
*/
	if (sdio_wait_bufferready_3(Card->membase) == SDIO_BUF_RDE)
	{
#ifdef SDIO_TC_INTERRUPT
		temp = mem_rDword(Card->membase+0x38);
		mem_wDword(Card->membase + 0x38, temp | SDIO_TRNC_UNMASK);
#endif		
		for (Read = 0; Read < Card->BlockSize; Read += 4)
			*lbuf++ = mem_rDword(Card->membase + 0x20);
	}
	else
		return -1;
#ifdef SDIO_TC_INTERRUPT
	ret2 = wait_event_interruptible(o2sd_pri_data.o2sd_tc_event,o2sd_pri_data.o2sd_tc);
	if(ret2==0)
		ret = 0;
	else if(ret2==-ERESTARTSYS)
	{
		printk("thread of wait o2sd_tc  received terminate\n");
		ret = -1;
	}
	else
	{
		printk("error value of waiting for o2sd_tc ret=%d\n",ret2);
		ret = -1;
	}
	/*
	waked so clear o2sd_tc  .
	*/
	set_pri_data(&(o2sd_pri_data.tc_lock),&(o2sd_pri_data.o2sd_tc),0);
	temp = mem_rDword(Card->membase+0x38);
	mem_wDword(Card->membase + 0x38, temp & SDIO_TRNC_MASK);
	
	if(o2sd_pri_data.sdio_err!=0)
	{
		set_pri_data(&(o2sd_pri_data.sdio_err_lock),&(o2sd_pri_data.sdio_err),0);
		return -1;
	}
	return ret;
#endif

/*
	KPRT("First dword %X%X\n",*(unsigned short*)buffer, *((unsigned short*)buffer + 1));
*/
//	temp2 = jiffies;
//	printk("read a sector jiffies %d\n",temp2-temp);
        return 0;
}

int sdio_if_readMsector( sdio_card_desc* Card,   void* buffer,  unsigned long block_address,unsigned long block_count)
{
	long ret,ret2;
	unsigned long temp,temp2; 
	unsigned long State;
	unsigned long flags;
	unsigned long* lbuf = (unsigned long)buffer;
	int Read = 0;
	int i;

	/* clean fifo */
	while ((State = sdio_get_status(Card->membase)) & SDIO_BUF_RDE) 
	{
		mem_rDword(Card->membase + 0x20);
	}
	while ((State = sdio_get_status(Card->membase)) & SDIO_BUF_WRE) 
	{
		PDEBUG("read:clean fifo for write ready"); 
		mem_wDword(Card->membase + 0x20, 0);
	}
	if ((State & SDIO_CARD_INS) == 0)
	{
		printk("Status not ready for read SDIO_CARD_INS\n");
		 return 2;
	}
	
	if (Card->BlockSize == 0 || Card->LBACount == 0) return 3;
	
	if (block_address >= Card->LBACount) return 4;
	
	block_address *= Card->BlockSize;
	mem_wWord(Card->membase + 0x6,(unsigned short)block_count);	

        sdio_get_interrupt(Card->membase);

	if(sdio_send_command(Card->membase, MMC_CMD18, block_address)<0)return 5;
	
	for(i = 0;i<block_count;i++)
	{
		if (sdio_wait_bufferready_3(Card->membase) == SDIO_BUF_RDE)
		{
#ifdef SDIO_TC_INTERRUPT
			temp = mem_rDword(Card->membase+0x38);
			mem_wDword(Card->membase + 0x38, temp | SDIO_TRNC_UNMASK);
#endif		
			for (Read = 0; Read < Card->BlockSize; Read += 4)
				*lbuf++ = mem_rDword(Card->membase + 0x20);
		}
		else
			return -1;
		if(i == block_count-1)
		{
	
#ifdef SDIO_TC_INTERRUPT
			ret2 = wait_event_interruptible(o2sd_pri_data.o2sd_tc_event,o2sd_pri_data.o2sd_tc);
			if(ret2==0)
			ret = 0;
			else if(ret2==-ERESTARTSYS)
			{
			printk("thread of wait o2sd_tc  received terminate\n");
			ret = -1;
			}
			else
			{
				printk("error value of waiting for o2sd_tc ret=%d\n",ret2);
				ret = -1;
			}
	/*
	waked so clear o2sd_tc  .
	*/
			set_pri_data(&(o2sd_pri_data.tc_lock),&(o2sd_pri_data.o2sd_tc),0);
			temp = mem_rDword(Card->membase+0x38);
			mem_wDword(Card->membase + 0x38, temp & SDIO_TRNC_MASK);
	
			if(o2sd_pri_data.sdio_err!=0)
			{
				set_pri_data(&(o2sd_pri_data.sdio_err_lock),&(o2sd_pri_data.sdio_err),0);
				return -1;
			}
			return ret;
#endif
		}
	}

        return 0;
}
int sdio_if_writeAsector( sdio_card_desc* Card,   void* buffer,  unsigned long block_address)
{
	long ret,ret2;
	unsigned long temp;
	int Wrotten = 0;
	unsigned long flags;	

	unsigned long State;
	unsigned long* lbuf = (unsigned long*)buffer;
	/* clean fifo */
	while ((State = sdio_get_status(Card->membase)) & SDIO_BUF_RDE) 
	{
		printk("write:clean fifo for read ready\n"); 
		mem_rDword(Card->membase + 0x20);
	}
	while ((State = sdio_get_status(Card->membase)) & SDIO_BUF_WRE) 
	{
		printk("write:clean fifo for write ready\n"); 
		mem_wDword(Card->membase + 0x20, 0);
	}

	/*
	if (State & (SDIO_RDT_ACT + SDIO_WRT_ACT + SDIO_DAT_ACT + SDIO_DATINHI + SDIO_CMDINHI)) return -1;
	*/
	if ((State & SDIO_CARD_INS) == 0) 
	{
		printk("card insert in wait cmd\n");
		return 2;
	}
	
	if (Card->BlockSize == 0 || Card->LBACount == 0)
	{
		printk("blocksize is 0 or lbacount is 0\n");
		 return 3;
	}
	
	if (block_address >= Card->LBACount)
	{
		printk("block address>lbacount\n");
		 return 4;
	}

	block_address *= Card->BlockSize;

        sdio_get_interrupt(Card->membase);

	if(sdio_send_command(Card->membase, MMC_CMD24, block_address)<0)return 5;
	if (sdio_wait_bufferready_4(Card->membase) == SDIO_BUF_WRE)
	{
#ifdef SDIO_TC_INTERRUPT
		temp = mem_rDword(Card->membase+0x38);
		mem_wDword(Card->membase + 0x38, temp | SDIO_TRNC_UNMASK);
#endif		
		for (Wrotten = 0; Wrotten < Card->BlockSize; Wrotten += 4)
			mem_wDword(Card->membase + 0x20, *lbuf++);
	}
	else
		return -1;
#ifdef SDIO_TC_INTERRUPT
	ret2 = wait_event_interruptible(o2sd_pri_data.o2sd_tc_event,o2sd_pri_data.o2sd_tc);
	if(ret2==0)
		ret = 0;
	else if(ret2==-ERESTARTSYS)
	{
		printk("thread of wait o2sd_tc  received terminate\n");
		ret = -1;
	}
	else
	{
		printk("error value of waiting for o2sd_tc ret=%d\n",ret2);
		ret = -1;
	}
	/*
	waked so clear o2sd_tc  .
	*/
	set_pri_data(&(o2sd_pri_data.tc_lock),&(o2sd_pri_data.o2sd_tc),0);
	temp = mem_rDword(Card->membase+0x38);
	mem_wDword(Card->membase + 0x38, temp & SDIO_TRNC_MASK);
	
	if(o2sd_pri_data.sdio_err!=0)
	{
		set_pri_data(&(o2sd_pri_data.sdio_err_lock),&(o2sd_pri_data.sdio_err),0);
		return -1;
	}
	return ret;
	
#endif
//      while (sdio_get_status(Card->membase) & 0x06);

        return 0;
}
int sdio_if_writeMsector( sdio_card_desc* Card,   void* buffer,  unsigned long block_address,unsigned long block_count)
{
	long ret,ret2;
	unsigned long temp;
	int Wrotten = 0;
	unsigned long flags;	
	int i;
	unsigned long State;
	unsigned long* lbuf = (unsigned long)buffer;
	
	State = sdio_get_status(Card->membase); 
	if ((State & SDIO_CARD_INS) == 0) return 2;
	
	if (Card->BlockSize == 0 || Card->LBACount == 0) return 3;
	
	if (block_address >= Card->LBACount) return 4;

	block_address *= Card->BlockSize;

	mem_wWord(Card->membase + 0x6,(unsigned short)block_count);	

        sdio_get_interrupt(Card->membase);

	if(sdio_send_command(Card->membase, MMC_CMD25, block_address)<0)return 5;
	for(i = 0;i<block_count;i++)
	{ 
		if (sdio_wait_bufferready_4(Card->membase) == SDIO_BUF_WRE)
		{
#ifdef SDIO_TC_INTERRUPT
			temp = mem_rDword(Card->membase+0x38);
			mem_wDword(Card->membase + 0x38, temp | SDIO_TRNC_UNMASK);
#endif	
			for (Wrotten = 0; Wrotten < Card->BlockSize; Wrotten += 4)
				mem_wDword(Card->membase + 0x20, *lbuf++);
		}
		else
			return -1;
		if(i==block_count-1)
		{
#ifdef SDIO_TC_INTERRUPT
			ret2 = wait_event_interruptible(o2sd_pri_data.o2sd_tc_event,o2sd_pri_data.o2sd_tc);
			if(ret2==0)
				ret = 0;
			else if(ret2==-ERESTARTSYS)
			{
				printk("thread of wait o2sd_tc  received terminate\n");
				ret = -1;
			}
			else
			{
				printk("error value of waiting for o2sd_tc ret=%d\n",ret2);
				ret = -1;
			}
	/*
	waked so clear o2sd_tc  .
	*/
			set_pri_data(&(o2sd_pri_data.tc_lock),&(o2sd_pri_data.o2sd_tc),0);
			temp = mem_rDword(Card->membase+0x38);
			mem_wDword(Card->membase + 0x38, temp & SDIO_TRNC_MASK);
	
			if(o2sd_pri_data.sdio_err!=0)
			{
				set_pri_data(&(o2sd_pri_data.sdio_err_lock),&(o2sd_pri_data.sdio_err),0);
				return -1;
			}
			return ret;
#endif
		}
	}

        return 0;
}
