/*
 * OZ711MS1 OZ711MP1 linux driver
 * O2Micro Inc.
 * toby.yang@o2micro.com
 * 2005/4/17
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
 *  A OZSCR PCMCIA client driver
 * Revisions 1.2.2
 * O2Micro Inc.
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _SDIO_INTERFACE_H_
#define _SDIO_INTERFACE_H_

#include "base.h"
#include "winif2.h"
#include "sdio.h"
#ifndef MAX_RETRY
#define MAX_RETRY 3
#endif

typedef struct sdio_host_info_tag
{
	_PCI_CONTEXT PciDevice;
	unsigned long memiobase;
	unsigned long NumberOfSlots;
} sdio_host_desc;

typedef struct sdio_card_info_tag
{
	unsigned char slot;     
	unsigned long membase;
	EVENT         Event;

	unsigned short PowerSelect;	
	unsigned short TransferMode;
	unsigned short BlockSize;
	unsigned long  LBACount;
	unsigned short LastCommand;
	
	unsigned long Capabilities;
	unsigned long PresentState;    
	
	unsigned long OCR;
	unsigned char o2sd_scsi_has_registered;	
	struct sdio_phy_registers r;
	
	sdio_host_desc* pHostDevice;
} sdio_card_desc;


int sdio_if_init(unsigned long membase, sdio_host_desc* pHostDevice);
int sdio_if_cleanup( sdio_host_desc* pHostDevice);

int sdio_if_getcardinfo(  sdio_card_desc* Card);

int sdio_if_readsector( sdio_card_desc* Card,   void* buffer,  unsigned long block_address,  unsigned long block_count);
int sdio_if_writesector( sdio_card_desc* Card,  void* buffer,  unsigned long block_address,  unsigned long block_count);
int sdio_if_readAsector( sdio_card_desc* Card,   void* buffer,  unsigned long block_address);
int sdio_if_writeAsector( sdio_card_desc* Card,   void* buffer,  unsigned long block_address);
int sdio_if_writeMsector( sdio_card_desc* Card,   void* buffer,  unsigned long block_address,unsigned long block_count);
                               
int sdio_if_hostreset( sdio_host_desc* pHostDevice);
int sdio_if_cardreset( sdio_card_desc* Card);
int sdio_if_chkMediaExist( sdio_card_desc* Card);
int sdio_if_chkWriteProtect( sdio_card_desc* Card);
                               
int sdio_if_interrupt_handler(sdio_host_desc* pHostDevice);
int sdio_if_interrupt_claim( sdio_host_desc* pHostDevice);
#endif
